import com.imsl.io.*;
import java.text.DateFormat;
import java.io.*;
import java.sql.SQLException;
import java.util.StringTokenizer;
import java.sql.Date;


public class FlatFileEx2 extends FlatFile {    
    static DateFormat dateFormat = DateFormat.getDateInstance();
    
    public FlatFileEx2(BufferedReader br, Tokenizer tokenizer) throws IOException {
        super(br, tokenizer);
        String line = readLine();
        StringTokenizer st = new StringTokenizer(line, " ", false);
        for (int j = 0;  st.hasMoreTokens();  j++) {
            setColumnName(j+1, st.nextToken().trim());
        }
        setColumnClass(1, Date.class); // Date
        setDateColumnParser(1, "dd-MMM-yy", java.util.Locale.US);
        setColumnClass(2, Double.class);  // Open
        setColumnClass(3, Double.class);  // High
        setColumnClass(4, Double.class);  // Low
        setColumnClass(5, Double.class);  // Close
        setColumnClass(6, Integer.class); // Volume
    }
 
    
    public static void main(String[] args) throws SQLException, IOException {
        InputStream is = FlatFileEx2.class.getResourceAsStream("SUNW.txt");
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        Tokenizer tokenizer = new Tokenizer(" ", (char)0, true);
        FlatFileEx2 reader = new FlatFileEx2(br, tokenizer);

        while (reader.next()) {
            Date date = reader.getDate("Date");
            double close = reader.getDouble("Close");
            int volume = reader.getInt("Volume");
            System.out.println(dateFormat.format(date) + "  " + close + "  " + volume);
        }
    }
}
